; -----------------------------------------------------------------------------
;	PSG BGM DRIVER
; =============================================================================
;	2009/09/30	t.hara
; -----------------------------------------------------------------------------

		.area	CODE (ABS)

; -----------------------------------------------------------------------------
;	AY-3-8910 (PSG) WX^`
; -----------------------------------------------------------------------------
PSG_REG_ADR			= 0xA0		; AhXb`
PSG_REG_WRT			= 0xA1		; f[^Cg

; -----------------------------------------------------------------------------
;	t^XN\̃ItZbg`
;	INFO_*
; -----------------------------------------------------------------------------
INFO_PLAY_ADR_L		= 0			; tAhX (0Ȃ~)
INFO_PLAY_ADR_H		= 1			; V
INFO_WAIT_COUNT_L	= 2			; ҋ@
INFO_WAIT_COUNT_H	= 3			; V
INFO_EFF_FREQ_L		= 4			; g
INFO_EFF_FREQ_H		= 5			; V
INFO_TONE_FREQ_L	= 6			; ݒg
INFO_TONE_FREQ_H	= 7			; V
INFO_EFF_VOL		= 8			; 
INFO_TONE_VOL		= 9			; ݒ艹
INFO_VIB_WAIT		= 10		; ru[gx
INFO_ENV_STATE		= 11		; Gx[vXe[g
INFO_ENV_VOL		= 12		; Gx[v
INFO_VIB_INDEX		= 13		; ru[gCfbNX
INFO_SOUND_FONT_L	= 14		; Ff[^̃AhX
INFO_SOUND_FONT_H	= 15		; V
INFO_SIZE			= 16		; INFO\̂̃TCY

; -----------------------------------------------------------------------------
;	Ff[^\̃ItZbg`
;	SFONT_*
; -----------------------------------------------------------------------------
SFONT_VIB_WAVE		= 0			; ru[gg`
SFONT_AR			= 32		; Gx[v AR
SFONT_DR			= 33		; Gx[v DR
SFONT_SL			= 34		; Gx[v SL
SFONT_SR			= 35		; Gx[v SR
SFONT_RR			= 36		; Gx[v RR
SFONT_VIB_WAIT		= 37		; ru[gx

; -----------------------------------------------------------------------------
;	
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
bgmdriver_initialize::
		ld		hl, #play_info_ch0
		ld		de, #play_info_ch0 + 1
		ld		bc, #INFO_SIZE * 3 - 1
		xor		a
		ld		(hl), a
		ldir
		ret

; -----------------------------------------------------------------------------
;	tJn
;	input:
;		hl	...	BGMf[^̃AhX
;	output
;		Ȃ
;	break
;		
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
bgmdriver_play::
		; ܂̉t~
		push	hl
		call	bgmdriver_stop
		pop		hl
		; tJn̂߂̏{
		di
		; ch0 ̉tf[^AhX擾
		ld		e, (hl)
		inc		hl
		ld		d, (hl)
		inc		hl
		ld		(play_info_ch0 + INFO_PLAY_ADR_L), de
		; ch1 ̉tf[^AhX擾
		ld		e, (hl)
		inc		hl
		ld		d, (hl)
		inc		hl
		ld		(play_info_ch1 + INFO_PLAY_ADR_L), de
		; ch2 ̉tf[^AhX擾
		ld		e, (hl)
		inc		hl
		ld		d, (hl)
		inc		hl
		ld		(play_info_ch2 + INFO_PLAY_ADR_L), de
		ei
		ret

; -----------------------------------------------------------------------------
;	t~
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		a
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
bgmdriver_stop::
		; ~̓rŊ荞܂ċsRɂȂȂ悤Ɋ
		di
		; ~
		ld		hl, #play_info_ch0
		call	bgmdriver_init_play_info
		ld		hl, #play_info_ch1
		call	bgmdriver_init_play_info
		ld		hl, #play_info_ch2
		call	bgmdriver_init_play_info
		; ։
		ei
		ret

; -----------------------------------------------------------------------------
;	t^XN[]
;	input:
;		hl	...	鉉t^XÑAhX
;	output
;		Ȃ
;	break
;		a, b, c, d, e, h, l
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
bgmdriver_init_play_info:
		ld		e, l
		ld		d, h
		inc		de
		ld		bc, #INFO_SIZE - 1
		xor		a
		ld		(hl), a
		ldir
		ret

; -----------------------------------------------------------------------------
;	t[`
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		Ȃ
;	comment
;		1/60bԊu call 邱Ƃ҂Ă郋[`łAʏ
;		H_TIMI tbN[`ĂяoB
;		荞ݏz肵Ă邽߁AWX^͔j󂵂ȂB
; -----------------------------------------------------------------------------
bgmdriver_interrupt_handler::
		; WX^Ҕ
		push	af
		push	bc
		push	de
		push	hl
		push	ix
		; t[`Ăяo
		ld		ix, #play_info_ch0
		call	bgmdriver_play_ch
		ld		ix, #play_info_ch1
		call	bgmdriver_play_ch
		ld		ix, #play_info_ch2
		call	bgmdriver_play_ch
		; ~LT[[`Ăяo
		call	bgmdriver_mixer
		; WX^A
		pop		ix
		pop		hl
		pop		de
		pop		bc
		pop		af
		ret

; -----------------------------------------------------------------------------
;	t[`(1ch) []
;	input:
;		ix	...	t{鉉t^XÑAhX
;	output
;		Ȃ
;	break
;		a, b, c, d, e, f, h, l
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
bgmdriver_play_ch:
		; tł邩ׂ
		ld		a, INFO_PLAY_ADR_L(ix)
		or		INFO_PLAY_ADR_H(ix)
		ret		z									; tłȂΉɒE
		; ҋ@Ԃł邩ׂ
		ld		l, INFO_WAIT_COUNT_L(ix)
		ld		h, INFO_WAIT_COUNT_H(ix)
		ld		a, l
		or		h
		jr		z, bgmdriver_check_next_data
		; ҋ@ԂXV
		dec		hl
		ld		INFO_WAIT_COUNT_L(ix), l
		ld		INFO_WAIT_COUNT_H(ix), h
		jp		bgmdriver_update_vibrato
		; ̉tf[^ǂݎ
bgmdriver_check_next_data:
		ld		l, INFO_PLAY_ADR_L(ix)
		ld		h, INFO_PLAY_ADR_H(ix)
		ld		a, (hl)
		inc		hl
		; tf[^fR[h
		cp		#96
		jp		c, bgmdriver_keyon					; 0`95  KeyOn bZ[W
		jp		z, bgmdriver_keyoff					; 96  KeyOff bZ[W
		cp		#98
		jp		c, bgmdriver_rest					; 97  xbZ[W
		jp		z, bgmdriver_volume					; 98  ʐݒ胁bZ[W
		cp		#100
		jp		c, bgmdriver_sound_font				; 99  Fݒ胁bZ[W
		jp		z, bgmdriver_jump					; 100  AhXWvbZ[W
		cp		#102
		jp		c, bgmdriver_play_end				; 101  t~bZ[W
		ret

		; KeyOn -----------------------------------------------------------
bgmdriver_keyon:
		ld		c, a								; j󂳂ȂWX^ɃobNAbv
		call	bgmdriver_get_wait_time
		ld		INFO_WAIT_COUNT_L(ix), e			; ҂ԍXV
		ld		INFO_WAIT_COUNT_H(ix), d
		ld		INFO_PLAY_ADR_L(ix), l				; tf[^
		ld		INFO_PLAY_ADR_H(ix), h
		ld		a, c								; 
		; Kgɕϊ
		rlca
		ld		l, a
		ld		h, #0
		ld		de, #freq_data
		add		hl, de								; hl  freq_data + a * 2
		ld		e, (hl)
		inc		hl
		ld		d, (hl)
		; ݒgXV
		ld		INFO_TONE_FREQ_L(ix), e
		ld		INFO_TONE_FREQ_H(ix), d
		; e평
		xor		a
		ld		INFO_ENV_STATE(ix), a
		ld		INFO_ENV_VOL(ix), a
		; ru[g
		ld		INFO_VIB_INDEX(ix), a
		ld		l, INFO_SOUND_FONT_L(ix)
		ld		h, INFO_SOUND_FONT_H(ix)
		ld		de, #SFONT_VIB_WAIT
		add		hl, de
		ld		a, (hl)
		ld		INFO_VIB_WAIT(ix), a
		jp		bgmdriver_update_vibrato

		; KeyOff -----------------------------------------------------------
bgmdriver_keyoff:
		call	bgmdriver_get_wait_time
		ld		INFO_WAIT_COUNT_L(ix), e			; ҂ԍXV
		ld		INFO_WAIT_COUNT_H(ix), d
		ld		INFO_PLAY_ADR_L(ix), l				; tf[^
		ld		INFO_PLAY_ADR_H(ix), h
		; Gx[v[XԂɕύX
		ld		a, INFO_ENV_STATE(ix)
		cp		#3
		jp		nc, bgmdriver_update_vibrato
		ld		INFO_ENV_STATE(ix), #3
		jp		bgmdriver_update_vibrato

		; x̏ ----------------------------------------------------------
bgmdriver_rest:
		call	bgmdriver_get_wait_time
		ld		INFO_WAIT_COUNT_L(ix), e			; ҂ԍXV
		ld		INFO_WAIT_COUNT_H(ix), d
		ld		INFO_PLAY_ADR_L(ix), l				; tf[^
		ld		INFO_PLAY_ADR_H(ix), h
		ld		INFO_ENV_STATE(ix), #4
		ld		INFO_ENV_VOL(ix), #0
		jp		bgmdriver_update_vibrato

		; ʐݒ ------------------------------------------------------------
bgmdriver_volume:
		ld		a, (hl)								; ʎ擾
		inc		hl
		ld		INFO_PLAY_ADR_L(ix), l				; tf[^
		ld		INFO_PLAY_ADR_H(ix), h
		ld		INFO_TONE_VOL(ix), a				; ݒ艹ʍXV
		jp		bgmdriver_check_next_data			; Ď̃f[^

		; Fݒ ------------------------------------------------------------
bgmdriver_sound_font:
		ld		e, (hl)								; Ff[^̃AhX擾
		inc		hl
		ld		d, (hl)
		inc		hl
		ld		INFO_PLAY_ADR_L(ix), l				; tf[^
		ld		INFO_PLAY_ADR_H(ix), h
		ld		INFO_SOUND_FONT_L(ix), e			; Ff[^AhXXV
		ld		INFO_SOUND_FONT_H(ix), d
		xor		a									; e평
		ld		INFO_VIB_WAIT(ix), a
		ld		INFO_ENV_STATE(ix), a
		ld		INFO_ENV_VOL(ix), a
		ld		INFO_VIB_INDEX(ix), a
		jp		bgmdriver_check_next_data			; Ď̃f[^

		; AhXWv ----------------------------------------------------
bgmdriver_jump:
		ld		e, (hl)								; ѐAhX擾
		inc		hl
		ld		d, (hl)
		ld		INFO_PLAY_ADR_L(ix), e				; tf[^
		ld		INFO_PLAY_ADR_H(ix), d
		jp		bgmdriver_check_next_data			; Ď̃f[^

		; t~ ------------------------------------------------------------
bgmdriver_play_end:
		xor		a
		ld		INFO_PLAY_ADR_L(ix), a				; t~
		ld		INFO_PLAY_ADR_H(ix), a
		ld		INFO_TONE_VOL(ix), a
		ld		INFO_ENV_STATE(ix), a
		ld		INFO_ENV_VOL(ix), a
		jp		bgmdriver_envelope_end				; ~̂Ńru[gGx[v̓XLbv

		; ru[g̏ ----------------------------------------------------
bgmdriver_update_vibrato:
		; ru[gxԂ̍Œł邩ׂ
		ld		a, INFO_VIB_WAIT(ix)
		or		a
		jr		z, bgmdriver_vibrato_active
		; ru[gxԂ̍Œ̏ꍇ
		dec		a
		ld		INFO_VIB_WAIT(ix), a				; x1JEgo
		; ݒg擾
		ld		l, INFO_TONE_FREQ_L(ix)
		ld		h, INFO_TONE_FREQ_H(ix)
		jp		bgmdriver_update_freq
		; ru[gxԂEĂꍇ
bgmdriver_vibrato_active:
		; ru[gʑʒu擾
		ld		a, INFO_VIB_INDEX(ix)
		ld		e, a
		inc		a
		and		#31
		ld		INFO_VIB_INDEX(ix), a				; ̈ʑ֐i߂Ă
		; ʑʒuɑΉru[gg`擾
		ld		d, #0
		ld		l, INFO_SOUND_FONT_L(ix)
		ld		h, INFO_SOUND_FONT_H(ix)
		add		hl, de
		ld		a, (hl)								; a  INFO_SOUND_FONT->SFONT_VIB_WAVE[ INFO_VIB_INDEX ]
		; ݒg擾
		ld		l, INFO_TONE_FREQ_L(ix)
		ld		h, INFO_TONE_FREQ_H(ix)
		; ru[gg`Z
		or		a
		jp		p, bgmdriver_vibrato_active_skip
		ld		d, #255
bgmdriver_vibrato_active_skip:
		ld		e, a
		add		hl, de
		; PSGɐݒ肳gXV
bgmdriver_update_freq:
		ld		INFO_EFF_FREQ_L(ix), l
		ld		INFO_EFF_FREQ_H(ix), h

		; Gx[v̏ --------------------------------------------------
		ld		l, INFO_SOUND_FONT_L(ix)
		ld		h, INFO_SOUND_FONT_H(ix)
		ld		d, #0
		ld		a, INFO_ENV_STATE(ix)				; 0: AR, 1: DR, 2: SR, 3: RR, 4: ~
		sub		#1
		jr		c, bgmdriver_envelope_ar
		jr		z, bgmdriver_envelope_dr
		sub		#2
		jr		c, bgmdriver_envelope_sr
		jr		z, bgmdriver_envelope_rr
		jp		bgmdriver_envelope_end
		; [XCg̏
bgmdriver_envelope_rr:
		ld		a, INFO_ENV_VOL(ix)
		ld		e, #SFONT_RR
		add		hl, de
		ld		b, (hl)
		sub		a, b
		ld		INFO_ENV_VOL(ix), a					; tOs
		jr		nc, bgmdriver_envelope_end
		ld		INFO_ENV_VOL(ix), #0
		ld		INFO_ENV_STATE(ix), #4				; ~Ɉڍs
		jp		bgmdriver_envelope_end
		; TXeBCg̏
bgmdriver_envelope_sr:
		ld		a, INFO_ENV_VOL(ix)
		ld		e, #SFONT_SR
		add		hl, de
		ld		b, (hl)
		sub		a, b
		ld		INFO_ENV_VOL(ix), a					; tOs
		jr		nc, bgmdriver_envelope_end
		ld		INFO_ENV_VOL(ix), #0
		ld		INFO_ENV_STATE(ix), #4				; ~Ɉڍs
		jp		bgmdriver_envelope_end
		; fBPCCg̏
bgmdriver_envelope_dr:
		ld		a, INFO_ENV_VOL(ix)
		ld		e, #SFONT_DR
		add		hl, de
		ld		b, (hl)
		inc		hl
		ld		c, (hl)
		sub		a, b
		ld		INFO_ENV_VOL(ix), a					; tOs
		cp		c
		jr		nc, bgmdriver_envelope_end
		ld		INFO_ENV_VOL(ix), c
		ld		INFO_ENV_STATE(ix), #2				; SR Ɉڍs
		jp		bgmdriver_envelope_end
		; A^bNCg̏
bgmdriver_envelope_ar:
		ld		a, INFO_ENV_VOL(ix)
		ld		e, #SFONT_AR
		add		hl, de
		ld		b, (hl)
		add		a, b
		ld		INFO_ENV_VOL(ix), a					; tOs
		cp		#15
		jr		c, bgmdriver_envelope_end
		ld		INFO_ENV_VOL(ix), #15
		ld		INFO_ENV_STATE(ix), #1				; DR Ɉڍs
		jp		bgmdriver_envelope_end
bgmdriver_envelope_end:

		; ʂvZ ------------------------------------------------------
		ld		a, INFO_TONE_VOL(ix)
		xor		#15
		ld		b, a
		ld		a, INFO_ENV_VOL(ix)
		sub		a, b
		jr		nc, bgmdriver_calc_eff_vol
		xor		a
bgmdriver_calc_eff_vol:
		ld		INFO_EFF_VOL(ix), a
		ret

; -----------------------------------------------------------------------------
;	҂ԓǂݎ菈 []
;	input:
;		hl	...	҂ԂL^Ă郁̃AhX
;	output
;		hl	...	҂Ԃ̎̃AhX
;		de	...	ǂݎ҂
;	break
;		a, f, d, e, h, l
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
bgmdriver_get_wait_time:
		ld		de, #0
bgmdriver_get_wait_time_loop:
		ld		a, (hl)
		inc		hl
		inc		a
		jr		nz, bgmdriver_get_wait_time_exit
		dec		a
		add		a, e
		jr		nc, bgmdriver_get_wait_time_loop
		inc		d
		jr		bgmdriver_get_wait_time_loop
bgmdriver_get_wait_time_exit:
		dec		a
		add		a, e
		ld		e, a
		jr		nc, bgmdriver_get_wait_time_skip
		inc		d
bgmdriver_get_wait_time_skip:
		ret

; -----------------------------------------------------------------------------
;	~LT[ []
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
bgmdriver_mixer:
		ld		c, #PSG_REG_ADR

		; ch0 gݒ
		ld		d, #0
		ld		ix, #play_info_ch0
		ld		a, INFO_EFF_FREQ_L(ix)		; SOUND 0, INFO_EFF_FREQ_L(ix)
		out		(c), d
		inc		d
		out		(PSG_REG_WRT), a
		ld		a, INFO_EFF_FREQ_H(ix)		; SOUND 1, INFO_EFF_FREQ_H(ix)
		out		(c), d
		inc		d
		out		(PSG_REG_WRT), a

		; ch1 gݒ
		ld		ix, #play_info_ch1
		ld		a, INFO_EFF_FREQ_L(ix)		; SOUND 2, INFO_EFF_FREQ_L(ix)
		out		(c), d
		inc		d
		out		(PSG_REG_WRT), a
		ld		a, INFO_EFF_FREQ_H(ix)		; SOUND 3, INFO_EFF_FREQ_H(ix)
		out		(c), d
		inc		d
		out		(PSG_REG_WRT), a

		; ch2 gݒ
		ld		ix, #play_info_ch2
		ld		a, INFO_EFF_FREQ_L(ix)		; SOUND 4, INFO_EFF_FREQ_L(ix)
		out		(c), d
		inc		d
		out		(PSG_REG_WRT), a
		ld		a, INFO_EFF_FREQ_H(ix)		; SOUND 5, INFO_EFF_FREQ_H(ix)
		out		(c), d
		inc		d
		out		(PSG_REG_WRT), a

		; ~LT[
		inc		d
		out		(c), d						; SOUND 7, &B10111000
		inc		d
		ld		a, #0xB8
		out		(PSG_REG_WRT), a

		; ch0 ʐݒ
		ld		ix, #play_info_ch0			; SOUND 8, INFO_EFF_VOL(ix)
		ld		a, INFO_EFF_VOL(ix)
		out		(c), d
		inc		d
		out		(PSG_REG_WRT), a

		; ch1 ʐݒ
		ld		ix, #play_info_ch1			; SOUND 9, INFO_EFF_VOL(ix)
		ld		a, INFO_EFF_VOL(ix)
		out		(c), d
		inc		d
		out		(PSG_REG_WRT), a

		; ch2 ʐݒ
		ld		ix, #play_info_ch2			; SOUND 10, INFO_EFF_VOL(ix)
		ld		a, INFO_EFF_VOL(ix)
		out		(c), d
		inc		d
		out		(PSG_REG_WRT), a

		ret

; -----------------------------------------------------------------------------
;	f[^GA
; -----------------------------------------------------------------------------
freq_data:
		.dw		#3420, #3228, #3047, #2876, #2714, #2562, #2418, #2282, #2154, #2033, #1919, #1811
		.dw		#1710, #1614, #1523, #1438, #1357, #1281, #1209, #1141, #1077, #1016,  #959,  #905
		.dw		 #855,  #807,  #761,  #719,  #678,  #640,  #604,  #570,  #538,  #508,  #479,  #452
		.dw		 #427,  #403,  #380,  #359,  #339,  #320,  #302,  #285,  #269,  #254,  #239,  #226
		.dw		 #213,  #201,  #190,  #179,  #169,  #160,  #151,  #142,  #134,  #127,  #119,  #113
		.dw		 #106,  #100,   #95,   #89,   #84,   #80,   #75,   #71,   #67,   #63,   #59,   #56
		.dw		  #53,   #50,   #47,   #44,   #42,   #40,   #37,   #35,   #33,   #31,   #29,   #28
		.dw		  #26,   #25,   #23,   #22,   #21,   #20,   #18,   #17,   #16,   #15,   #14,   #14

; -----------------------------------------------------------------------------
;	[NGA
; -----------------------------------------------------------------------------
play_info_ch0:
		.ds		INFO_SIZE
play_info_ch1:
		.ds		INFO_SIZE
play_info_ch2:
		.ds		INFO_SIZE
