@echo off

set path_back=%PATH%
set PATH=..\bin

if exist *.o (
	del /Q *.o > nul
)
if exist *.ihx (
	del /Q *.ihx > nul
)
if exist *.map (
	del /Q *.map > nul
)
if exist *.bin (
	del /Q *.bin > nul
)

echo [ASSEMBLE] bgmdriver.asm
as-z80 -o bgmdriver.o bgmdriver.asm

echo [ASSEMBLE] bgmdriver_if.asm
as-z80 -o bgmdriver_if.o bgmdriver_if.asm

echo [LINK] bgmdriver.ihx
link-z80 -nf bgmdriver.link

echo [BSAVE] bgmdriver.bin
ihx2bin bgmdriver.ihx diskimage\bgmdrv.bin > nul

del *.o

set PATH=%path_back%
pause
